#include <bits/stdc++.h>

using namespace std;

string s;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL); cout.tie(NULL);
	
	int n, c, q;
	
	cin >> n >> c >> q;
	
	cin >> s;
	
	int k = 0;
	
	if(c == n)
	{
		for(int i = 0; i < n; i++) 
		if(s[i] == '1') k++;
		
		
		while(q--)
		{
			int l, r;
			
			cin >> l >> r;
			
			l--;
			r--;
			
			for(int i = l; i <= r; i++)
			{
				if(s[i] == '1')
				{
				 	s[i] = '0';
				 	k--;
				}
				else
				{
					s[i] = '1';
					k++;
				}
			}
			
			cout << k << "\n";
		}
	}
	else
	{
		for(int i = 0; i < n; i++)
		{
			if(s[i] == '1')
			{
				while(s[i] == '1') i++;
				
				k++;
			}
		}
		
		while(q--)
		{
			int l, r;
			
			cin >> l >> r;
			
			l--;
			r--;
			
			for(int i = l; i <= r; i++)
			{
				if(s[i] == '0')
					s[i] = '1';
				else s[i] = '0';
			}
		
			k = 0;
			
			for(int i = 0; i < n; i++)
			{
				if(s[i] == '1')
				{
					while(s[i] == '1') i++;
					
					k++;
				}
			}
			
			cout << k << "\n";
				
		}
	}
	
	return 0;
}